(function($, Drupal, window) {

  Drupal.behaviors.chaseOrbitalHpf = {
    attach: function (context, settings) {
      // Frame being viewed by user
      if (top === self) {
        window.cancelCREPayment = this.cancelCREPayment;
        window.whatCVV2 = this.whatCVV2;
        window.creHandleErrors = this.creHandleErrors;
        window.creHandleDetailErrors = this.creHandleDetailErrors;
        window.startCREPayment = this.startCREPayment;
        window.completeCREPayment = this.completeCREPayment;
      } else {
        // We are embedded in the hosted payment frame.
        var hpfParams = settings.chaseOrbitalHpf;

        if (hpfParams.cancel !== null && (hpfParams.cancel === 1 || hpfParams.cancel === 2 )) {
          window.top.cancelCREPayment(hpfParams.cancel, hpfParams.cancelUrl);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
        else if (hpfParams.whatCVV2 !== null || hpfParams.whatsThis !== null) {
          window.top.whatCVV2(hpfParams.whatsThis);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
        else if (hpfParams.processStart == "1") {
          window.top.startCREPayment();
        }
        else if (hpfParams.errorCode === null) {
          var transaction = {};
          // Taken from example callback JavaScript to build transaction object.
          var qStr = window.location.search.substring(1);
          var qStrParts = qStr.split("&");
          for (var i = 0; i < qStrParts.length; i++) {
            var qStrNV = qStrParts[i].split("=");
            transaction[qStrNV[0]] = qStrNV[1];
          }
          window.top.completeCREPayment( transaction, hpfParams.returnUrl );
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";

        }
        else {
          window.top.creHandleDetailErrors(hpfParams.errorCode, hpfParams.gatewayCode, hpfParams.gatewayMessage, hpfParams.cancelUrl);
          document.getElementById("loadingCompleteFrame").src = hpfParams.currentLocation + "?creReserved=r";
        }
      }
    },
    cancelCREPayment: function (cancel, cancelUrl) {
      window.top.location = cancelUrl
    },
    whatCVV2: function () {
      var string = Drupal.t('The CVV Number ("Card Verification Value") on your credit card or debit card is a 3 digit number on VISA®, MasterCard® and Discover® branded credit and debit cards. On your American Express® branded credit or debit card it is a 4 digit numeric code.');
      // @todo add Drupal.theme implementation and preprend above iframe, or something.
      alert(string);
    },
    creHandleErrors: function (errorCode, cancelUrl) {
      console.log(errorCode);
      window.top.location.href = cancelUrl + "?errorCode=" + errorCode;
    },
    creHandleDetailErrors: function (errorCode, gatewayCode, gatewayMessage, cancelUrl) {
      console.log(errorCode);
      console.log(cancelUrl);
      window.top.location.href = cancelUrl + "?errorCode=" + errorCode + "&gatewayCode=" + gatewayCode + "&gatewayMessage=" + gatewayMessage;
    },
    startCREPayment: function () {
      // Override this method to manipulate checkout page.
    },
    completeCREPayment: function (transaction, returnUrl) {
      window.top.location = returnUrl + "?transaction=" + encodeURIComponent(JSON.stringify(transaction));
    }
  }

})(jQuery, window.Drupal, window);
