<?php

/**
 * @file
 * API Documentation for Chase Paymentech Orbital Hosted Payment Form.
 */

/**
 * Allows modules or themes to manipulate iFrame output for payment gateway.
 *
 * @param array $attributes
 *    Array of attributes to be sent to drupal_attributes.
 * @param array $payment_method
 *    Payment method instance.
 * @param object $order
 *    The current order object.
 */
function hook_commerce_chase_orbital_hpf_iframe_attributes_alter(array &$attributes, array $payment_method, $order) {
  // Remove width and height to control directly with CSS.
  unset($attributes['width']);
  unset($attributes['height']);
}

/**
 * Allows modules or themes to manupulate the iFrame query parameters.
 *
 * @param array $query
 *    Array of parameters appended to the iFrame URL to build the iFrame.
 * @param $payment_method
 *    The active payment method instance
 * @param $order
 *    The current order.
 */
function hook_commerce_chase_orbital_hpf_iframe_query_alter(array &$query, $payment_method, $order) {
  // use a custom CSS stylesheet to style the iframe
  $query['css_url'] = url(drupal_get_path('module', 'mytheme') . '/css/commerce-chase-orbital-hpf.css', array('absolute' => TRUE));
}
